// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Design implementation internals
// See Vsecret_impl.h for the primary calling header

#include "Vsecret_impl__pch.h"
#include "Vsecret_impl_PSt25l.h"

void Vsecret_impl_PSt25l__PSIvHX(Vsecret_impl_PSt25l* vlSelf) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    Vsecret_impl_PSt25l__PSIvHX\n"); );
    Vsecret_impl_PSru5B* const __restrict vlSymsp VL_ATTR_UNUSED = vlSelf->vlSymsp;
    auto& vlSelfRef = std::ref(*vlSelf).get();
}

void Vsecret_impl_PSt25l__PSZZxu(Vsecret_impl_PSt25l* vlSelf);

void Vsecret_impl_PSt25l__PS0tLF(Vsecret_impl_PSt25l* vlSelf) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    Vsecret_impl_PSt25l__PS0tLF\n"); );
    Vsecret_impl_PSru5B* const __restrict vlSymsp VL_ATTR_UNUSED = vlSelf->vlSymsp;
    auto& vlSelfRef = std::ref(*vlSelf).get();
    // Body
    if ((1ULL & vlSelfRef.PSchC3.word(0U))) {
        Vsecret_impl_PSt25l__PSZZxu(vlSelf);
    }
}

VL_INLINE_OPT void Vsecret_impl_PSt25l__PSZZxu(Vsecret_impl_PSt25l* vlSelf) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    Vsecret_impl_PSt25l__PSZZxu\n"); );
    Vsecret_impl_PSru5B* const __restrict vlSymsp VL_ATTR_UNUSED = vlSelf->vlSymsp;
    auto& vlSelfRef = std::ref(*vlSelf).get();
    // Init
    IData PSMPu7;
    PSMPu7 = 0;
    // Body
    PSMPu7 = vlSelfRef.PSyUog;
    PSMPu7 = (vlSelfRef.PSyUog + vlSelfRef.a);
    vlSelfRef.x = ((0xaU < vlSelfRef.PSyUog) ? vlSelfRef.b
                    : ((IData)(9U) + (vlSelfRef.a + vlSelfRef.b)));
    vlSelfRef.PSyUog = PSMPu7;
}

void Vsecret_impl_PSt25l__PSJN9b(Vsecret_impl_PSt25l* vlSelf);

bool Vsecret_impl_PSt25l__PSUbvX(Vsecret_impl_PSt25l* vlSelf) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    Vsecret_impl_PSt25l__PSUbvX\n"); );
    Vsecret_impl_PSru5B* const __restrict vlSymsp VL_ATTR_UNUSED = vlSelf->vlSymsp;
    auto& vlSelfRef = std::ref(*vlSelf).get();
    // Init
    VlTriggerVec<1> PSoTLM;
    CData PSfsHi;
    // Body
    Vsecret_impl_PSt25l__PSJN9b(vlSelf);
    PSfsHi = vlSelfRef.PSiCQe.any();
    if (PSfsHi) {
        PSoTLM.andNot(vlSelfRef.PSiCQe, vlSelfRef.PSchC3);
        vlSelfRef.PSchC3.thisOr(vlSelfRef.PSiCQe);
        Vsecret_impl_PSt25l__PSIvHX(vlSelf);
    }
    return (PSfsHi);
}

bool Vsecret_impl_PSt25l__PSso1U(Vsecret_impl_PSt25l* vlSelf) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    Vsecret_impl_PSt25l__PSso1U\n"); );
    Vsecret_impl_PSru5B* const __restrict vlSymsp VL_ATTR_UNUSED = vlSelf->vlSymsp;
    auto& vlSelfRef = std::ref(*vlSelf).get();
    // Init
    CData PSVynM;
    // Body
    PSVynM = vlSelfRef.PSchC3.any();
    if (PSVynM) {
        Vsecret_impl_PSt25l__PS0tLF(vlSelf);
        vlSelfRef.PSchC3.clear();
    }
    return (PSVynM);
}

#ifdef VL_DEBUG
VL_ATTR_COLD void Vsecret_impl_PSt25l__PS6uzJ(Vsecret_impl_PSt25l* vlSelf);
#endif  // VL_DEBUG
#ifdef VL_DEBUG
VL_ATTR_COLD void Vsecret_impl_PSt25l__PSBLa7(Vsecret_impl_PSt25l* vlSelf);
#endif  // VL_DEBUG

void Vsecret_impl_PSt25l__PSXZlq(Vsecret_impl_PSt25l* vlSelf) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    Vsecret_impl_PSt25l__PSXZlq\n"); );
    Vsecret_impl_PSru5B* const __restrict vlSymsp VL_ATTR_UNUSED = vlSelf->vlSymsp;
    auto& vlSelfRef = std::ref(*vlSelf).get();
    // Init
    IData PSCeAC;
    CData PSIclZ;
    // Body
    PSCeAC = 0U;
    PSIclZ = 1U;
    while (PSIclZ) {
        if (VL_UNLIKELY(((0x64U < PSCeAC)))) {
#ifdef VL_DEBUG
            Vsecret_impl_PSt25l__PS6uzJ(vlSelf);
#endif
            VL_FATAL_MT("PSBD1z", 10, "", "NBA region did not converge.");
        }
        PSCeAC = ((IData)(1U) + PSCeAC);
        PSIclZ = 0U;
        vlSelfRef.PSQAgx = 0U;
        vlSelfRef.PSYK4a = 1U;
        while (vlSelfRef.PSYK4a) {
            if (VL_UNLIKELY(((0x64U < vlSelfRef.PSQAgx)))) {
#ifdef VL_DEBUG
                Vsecret_impl_PSt25l__PSBLa7(vlSelf);
#endif
                VL_FATAL_MT("PSBD1z", 10, "", "Active region did not converge.");
            }
            vlSelfRef.PSQAgx = ((IData)(1U) + vlSelfRef.PSQAgx);
            vlSelfRef.PSYK4a = 0U;
            if (Vsecret_impl_PSt25l__PSUbvX(vlSelf)) {
                vlSelfRef.PSYK4a = 1U;
            }
        }
        if (Vsecret_impl_PSt25l__PSso1U(vlSelf)) {
            PSIclZ = 1U;
        }
    }
}

#ifdef VL_DEBUG
void Vsecret_impl_PSt25l__PSbfPo(Vsecret_impl_PSt25l* vlSelf) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    Vsecret_impl_PSt25l__PSbfPo\n"); );
    Vsecret_impl_PSru5B* const __restrict vlSymsp VL_ATTR_UNUSED = vlSelf->vlSymsp;
    auto& vlSelfRef = std::ref(*vlSelf).get();
    // Body
    if (VL_UNLIKELY(((vlSelfRef.clk & 0xfeU)))) {
        Verilated::overWidthError("clk");}
}
#endif  // VL_DEBUG
